package errorReachableAnalyzer;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class MultiConcurrentModel implements ModelInterface {
	HashMap<String,MultiConcurrentState> states;
	List<String> statesName;
	HashMap<String,MultiConcurrentState> errorStatesOfReq;
	List<String> errorStatesName;
	List<Transition> updatePart=new ArrayList<Transition>();
	MultiConcurrentState initState;
	
	public MultiConcurrentModel(MultiConcurrentState initState) {
		this.initState=initState;
		this.errorStatesOfReq=new HashMap<String,MultiConcurrentState>();
		this.errorStatesName=new ArrayList<String>();
		this.states=new HashMap<String,MultiConcurrentState>();
		this.statesName=new ArrayList<String>();
		this.errorStatesOfReq=new HashMap<String,MultiConcurrentState>();
	}
	public void addMultiConcurrentState(MultiConcurrentState mcs){
		states.put(mcs.name, mcs);
		statesName.add(mcs.name);
	}
	public MultiConcurrentState getConcurrentState(State env,List<State> reqMoni){
		String s=env.toString();
		for(int i=0;i<reqMoni.size();i++)s=s.concat(reqMoni.get(i).toString());
		return states.get(s);
	}
	public boolean existsConcurrentState(State env,List<State> reqMoni){
		String s=env.toString();
		for(int i=0;i<reqMoni.size();i++)s=s.concat(reqMoni.get(i).toString());
		return states.get(s)!=null;
	}
	public MultiConcurrentState getState(int i){
		return states.get(statesName.get(i));
	}
	@Override
	public int getSize() {
		// TODO ꂽ\bhEX^u
		return statesName.size();
	}
	public int getErrorSize(){
		return errorStatesOfReq.size();
	}
	@Override
	public State getInitState() {
		// TODO ꂽ\bhEX^u
		return getState(0);
	}

	@Override
	public State getErrorState() {
		// TODO ꂽ\bhEX^u
		return this.errorStatesOfReq.get("ERROR0");
	}
	public State getErrorState(int i) {
		// TODO ꂽ\bhEX^u
		return this.errorStatesOfReq.get(errorStatesName.get(i));
	}

	public State getErrorState(String s,int reqMoniNum){
		if(this.errorStatesOfReq.get(s)==null){
			MultiConcurrentState emcs=new MultiConcurrentState(s,reqMoniNum);
			String[] errors=s.split("ERROR");
			for(int i=1;i<errors.length;i++){
//				System.out.println(errors[i]);
				emcs.setIsDead(Integer.parseInt(errors[i]));
			}
			this.errorStatesOfReq.put(s, new MultiConcurrentState(s,reqMoniNum));
			this.errorStatesName.add(s);
		}
		return this.errorStatesOfReq.get(s);
	}
	@Override
	public List<Transition> getUpdatedPart() {
		// TODO ꂽ\bhEX^u
		return updatePart;
	}
	public State getState(String s) {
		return states.get(states);
	}
	
}
